package org.apache.bcel.generic;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.ClassElementValue;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.ElementValue;

/* loaded from: org_apache_bcel_generic.jar:org/apache/bcel/generic/ClassElementValueGen.class */
public class ClassElementValueGen extends ElementValueGen {
    private final int idx;

    public ClassElementValueGen(ClassElementValue value, ConstantPoolGen cpool, boolean copyPoolEntries) {
        super(99, cpool);
        if (copyPoolEntries) {
            this.idx = cpool.addUtf8(value.getClassString());
        } else {
            this.idx = value.getIndex();
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public ClassElementValueGen(int typeIdx, ConstantPoolGen cpool) {
        super(99, cpool);
        this.idx = typeIdx;
    }

    public ClassElementValueGen(ObjectType t, ConstantPoolGen cpool) {
        super(99, cpool);
        this.idx = cpool.addUtf8(t.getSignature());
    }

    @Override // org.apache.bcel.generic.ElementValueGen
    public void dump(DataOutputStream dos) throws IOException {
        dos.writeByte(super.getElementValueType());
        dos.writeShort(this.idx);
    }

    public String getClassString() {
        ConstantUtf8 cu8 = getConstantPool().getConstant(this.idx);
        return cu8.getBytes();
    }

    @Override // org.apache.bcel.generic.ElementValueGen
    public ElementValue getElementValue() {
        return new ClassElementValue(super.getElementValueType(), this.idx, getConstantPool().getConstantPool());
    }

    public int getIndex() {
        return this.idx;
    }

    @Override // org.apache.bcel.generic.ElementValueGen
    public String stringifyValue() {
        return getClassString();
    }
}
